#!/usr/bin/env python
#
# AppTool
# Copyright (C) 2010  Nathan Forbes
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import os
import pwd
import shutil

import common
import cli

def restoreApps():
  try:
    home = common.mainWorkDir()
    filename = '%s_AppBackup.zip' % (pwd.getpwuid(os.getuid()).pw_name)
    if not os.path.isdir(home):
      return cli.error("AppTool directory not found, have you ran the `backup' option?")
    if not os.path.isfile(os.path.join(home, filename)):
      return cli.error("No backed up apps were found!")
    cli.message("Uncompressing previous backed up apps")
    os.chdir(home)
    exzip = common.ZipUtil(zipextract=True, zipname=filename)
    exzip.work()
    cli.message("Attempting to reinstall apps")
    for apk in os.listdir(os.path.join(home, 'app')):
      if apk:
        common.adbInstall(os.path.join(home, 'app', apk))
    for apk in os.listdir(os.path.join(home, 'app-private')):
      if apk:
        common.adbInstall(os.path.join(home, 'app-private', apk))
    cli.success("Done restoring")
    shutil.rmtree(os.path.join(home, 'Apps'))
  except:
    cli.warning("Aborting...")
    if os.path.isdir(os.path.join(home, 'app')):
      shutil.rmtree(os.path.join(home, 'app'))
    if os.path.isdir(os.path.join(home, 'app-private')):
      shutil.rmtree(os.path.join(home, 'app-private'))
